Index: typo3/sysext/rtehtmlarea/class.tx_rtehtmlarea_base.php
===================================================================
--- typo3/sysext/rtehtmlarea/class.tx_rtehtmlarea_base.php	(revision 3287)
+++ typo3/sysext/rtehtmlarea/class.tx_rtehtmlarea_base.php	(working copy)
@@ -539,8 +539,8 @@
 			bar, textcolor, bgcolor, textindicator,
 			bar, emoticon, insertcharacter, line, link, unlink, image, table,' . (($this->thisConfig['hideTableOperationsInToolbar'] && is_array($this->thisConfig['buttons.']) && is_array($this->thisConfig['buttons.']['toggleborders.']) && $this->thisConfig['buttons.']['toggleborders.']['keepInToolbar']) ? ' toggleborders,': '') . ' user, acronym, bar, findreplace, spellcheck,
 			bar, chMode, inserttag, removeformat, bar, copy, cut, paste, bar, undo, redo, bar, showhelp, about, linebreak, 
-			' . ($this->thisConfig['hideTableOperationsInToolbar'] ? '': 'bar, toggleborders,') . ' bar, tableproperties, bar, rowproperties, rowinsertabove, rowinsertunder, rowdelete, rowsplit, bar,
-			columninsertbefore, columninsertafter, columndelete, columnsplit, bar,
+			' . ($this->thisConfig['hideTableOperationsInToolbar'] ? '': 'bar, toggleborders,') . ' bar, tableproperties, tablerestyle, bar, rowproperties, rowinsertabove, rowinsertunder, rowdelete, rowsplit, bar,
+			columnproperties, columninsertbefore, columninsertafter, columndelete, columnsplit, bar,
 			cellproperties, cellinsertbefore, cellinsertafter, celldelete, cellsplit, cellmerge';
 		
 			// Special toolbar for Mozilla Wamcom on Mac OS 9
@@ -551,8 +551,8 @@
 				bar, orderedlist, unorderedlist, outdent, indent, bar, textcolor, bgcolor, textindicator, bar, emoticon,
 				insertcharacter, line, link, unlink, image, table, user, acronym, bar, findreplace, spellcheck, bar, chMode, inserttag,
 				removeformat, bar, copy, cut, paste, bar, undo, redo, bar, showhelp, about, linebreak,
-				bar, toggleborders, bar, tableproperties, bar, rowproperties, rowinsertabove, rowinsertunder, rowdelete, rowsplit, bar,
-				columninsertbefore, columninsertafter, columndelete, columnsplit, bar,
+				bar, toggleborders, bar, tableproperties, tablerestyle, bar, rowproperties, rowinsertabove, rowinsertunder, rowdelete, rowsplit, bar,
+				columnproperties, columninsertbefore, columninsertafter, columndelete, columnsplit, bar,
 				cellproperties, cellinsertbefore, cellinsertafter, celldelete, cellsplit, cellmerge'
 				: 'bar, blockstylelabel, blockstyle, space, textstylelabel, textstyle, linebreak,
 				bar, fontstyle, space, fontsize, space, formatblock, insertparagraphbefore, insertparagraphafter, blockquote, bar, bold, italic, underline, strikethrough,
@@ -560,8 +560,8 @@
 				orderedlist, unorderedlist, outdent, indent, bar, textcolor, bgcolor, textindicator, bar, emoticon,
 				insertcharacter, line, link, unlink, image, table, user, acronym, linebreak, bar, findreplace, spellcheck, bar, chMode, inserttag,
 				removeformat, bar, copy, cut, paste, bar, undo, redo, bar, showhelp, about, linebreak,
-				bar, toggleborders, bar, tableproperties, bar, rowproperties, rowinsertabove, rowinsertunder, rowdelete, rowsplit, bar,
-				columninsertbefore, columninsertafter, columndelete, columnsplit, bar,
+				bar, toggleborders, bar, tableproperties, tablerestyle, bar, rowproperties, rowinsertabove, rowinsertunder, rowdelete, rowsplit, bar,
+				columnproperties, columninsertbefore, columninsertafter, columndelete, columnsplit, bar,
 				cellproperties, cellinsertbefore, cellinsertafter, celldelete, cellsplit, cellmerge';
 		}
 		
@@ -737,8 +737,7 @@
 			};
 			RTEarea = new Array();
 			RTEarea[0] = new Object();
-			RTEarea[0]["version"] = "' . $TYPO3_CONF_VARS['EXTCONF'][$this->ID]['version'] . '";
-			RTEarea[0]["popupwin"] = "' . $this->writeTemporaryFile('EXT:' . $this->ID . '/htmlarea/popupwin.js', "popupwin") . '";'
+			RTEarea[0]["version"] = "' . $TYPO3_CONF_VARS['EXTCONF'][$this->ID]['version'] . '";'
 			. (($this->client['BROWSER'] == 'msie') ? ('
 			RTEarea[0]["htmlarea-ie"] = "' . $this->writeTemporaryFile('EXT:' . $this->ID . '/htmlarea/htmlarea-ie.js', "htmlarea-ie") . '";')
 			: ('
@@ -810,7 +809,8 @@
 			RTEarea['.$RTEcounter.'].id = "RTEarea'.$RTEcounter.'";
 			RTEarea['.$RTEcounter.'].enableWordClean = ' . (trim($this->thisConfig['enableWordClean'])?'true':'false') . ';
 			RTEarea['.$RTEcounter.']["htmlRemoveComments"] = ' . (trim($this->thisConfig['removeComments'])?'true':'false') . ';
-			RTEarea['.$RTEcounter.']["disableEnterParagraphs"] = ' . (trim($this->thisConfig['disableEnterParagraphs'])?'true':'false') . ';
+			RTEarea['.$RTEcounter.'].disableEnterParagraphs = ' . (trim($this->thisConfig['disableEnterParagraphs'])?'true':'false') . ';
+			RTEarea['.$RTEcounter.'].disableObjectResizing = ' . (trim($this->thisConfig['disableObjectResizing'])?'true':'false') . ';
 			RTEarea['.$RTEcounter.']["removeTrailingBR"] = ' . (trim($this->thisConfig['removeTrailingBR'])?'true':'false') . ';
 			RTEarea['.$RTEcounter.']["useCSS"] = ' . (trim($this->thisConfig['useCSS'])?'true':'false') . ';
 			RTEarea['.$RTEcounter.']["keepButtonGroupTogether"] = ' . (trim($this->thisConfig['keepButtonGroupTogether'])?'true':'false') . ';
@@ -845,67 +845,8 @@
 			foreach ($this->thisConfig['buttons.'] as $buttonIndex => $conf) {
 				$button = substr($buttonIndex, 0, -1);
 				if (in_array($button,$this->toolbar)) {
-					$indexButton = 0;
 					$configureRTEInJavascriptString .= '
-			RTEarea['.$RTEcounter.'].buttons.'.$button.' = {';
-					if (is_array($conf)) {
-						foreach ($conf as $propertyName => $conf1) {
-							$property = $propertyName;
-							if ($indexButton) {
-								$configureRTEInJavascriptString .= ', ';
-							}
-							if (is_array($conf1)) {
-								$property = substr($property, 0, -1);
-								$indexProperty = 0;
-								$configureRTEInJavascriptString .= '"'.$property.'" : {';
-								foreach ($conf1 as $property1Name => $conf2) {
-									$property1 = $property1Name;
-									if ($indexProperty) {
-										$configureRTEInJavascriptString .= ', ';
-									}
-									if (is_array($conf2)) {
-										$property1 = substr($property1, 0, -1);
-										$indexProperty1 = 0;
-										$configureRTEInJavascriptString .= '"'.$property1.'" : {';
-										foreach ($conf2 as $property2Name => $conf3) {
-											$property2 = $property2Name;
-											if ($indexProperty1) {
-												$configureRTEInJavascriptString .= ', ';
-											}
-											if (is_array($conf3)) {
-												$property2 = substr($property2, 0, -1);
-												$indexProperty2 = 0;
-												$configureRTEInJavascriptString .= '"'.$property2.'" : {';
-												foreach($conf3 as $property3Name => $conf4) {
-													$property3 = $property3Name;
-													if ($indexProperty2) {
-														$configureRTEInJavascriptString .= ', ';
-													}
-													if (!is_array($conf4)) {
-														$configureRTEInJavascriptString .= '"'.$property3.'" : '.($conf4?'"'.$conf4.'"':'false');
-													}
-													$indexProperty2++;
-												}
-												$configureRTEInJavascriptString .= '}';
-											} else {
-												$configureRTEInJavascriptString .= '"'.$property2.'" : '.($conf3?'"'.$conf3.'"':'false');												
-											}
-											$indexProperty1++;
-										}
-										$configureRTEInJavascriptString .= '}';
-									} else {
-										$configureRTEInJavascriptString .= '"'.$property1.'" : '.($conf2?'"'.$conf2.'"':'false');
-									}
-									$indexProperty++;
-								}
-								$configureRTEInJavascriptString .= '}';
-							} else {
-								$configureRTEInJavascriptString .= '"'.$property.'" : '.($conf1?'"'.$conf1.'"':'false');
-							}
-							$indexButton++;
-						}
-					}
-					$configureRTEInJavascriptString .= '};';
+			RTEarea['.$RTEcounter.'].buttons.'.$button.' = ' . $this->buildNestedJSArray($conf) . ';';
 				}
 			}
 		}
@@ -1058,9 +999,12 @@
 		
 		$linebreak = $TYPO3_CONF_VARS['EXTCONF'][$this->ID]['enableCompressedScripts'] ? '' : chr(10);
 		$index = 0;
+		$indexNoShow = 0;
+		$indexAlternating = 0;
 		$JSClassesLabelsArray = 'HTMLArea.classesLabels = { ' . $linebreak;
 		$JSClassesValuesArray = 'HTMLArea.classesValues = { ' . $linebreak;
 		$JSClassesNoShowArray = 'HTMLArea.classesNoShow = { ' . $linebreak;
+		$JSClassesAlternatingArray = 'HTMLArea.classesAlternating = { ' . $linebreak;
 		$JSClassesXORArray = 'HTMLArea.classesXOR = { ' . $linebreak;
 		
 			// Scanning the list of classes if specified in the RTE config
@@ -1069,13 +1013,20 @@
 			foreach ($RTEProperties['classes.'] as $className => $conf) {
 				$className = substr($className,0,-1);
 				$classLabel = $this->getPageConfigLabel($conf['name']);
-				$JSClassesLabelsArray .= (($index)?',':'') . '"' . $className . '": ' . $classLabel . $linebreak;
-				$JSClassesValuesArray .= (($index)?',':'') . '"' . $className . '":"' . str_replace('"', '\"', str_replace('\\\'', '\'', $conf['value'])) . '"' . $linebreak;
-				$JSClassesNoShowArray .= (($index)?',':'') . '"' . $className . '":' . ($conf['noShow']?'true':'false') . $linebreak;
+				$JSClassesLabelsArray .= ($index?',':'') . '"' . $className . '": ' . $classLabel . $linebreak;
+				$JSClassesValuesArray .= ($index?',':'') . '"' . $className . '":"' . str_replace('"', '\"', str_replace('\\\'', '\'', $conf['value'])) . '"' . $linebreak;
+				if ($conf['noShow']) {
+					$JSClassesNoShowArray .= ($indexNoShow?',':'') . '"' . $className . '":' . ($conf['noShow']?'true':'false') . $linebreak;
+					$indexNoShow++;
+				}
+				if (is_array($conf['alternating.'])) {
+					$JSClassesAlternatingArray .= ($indexAlternating?',':'') . '"' . $className . '":' . (is_array($conf['alternating.']) ? $this->buildNestedJSArray($conf['alternating.']) : ' "false"') . $linebreak;
+					$indexAlternating++;
+				}
 				if (is_array($RTEProperties['mutuallyExclusiveClasses.']))  {
 					foreach ($RTEProperties['mutuallyExclusiveClasses.'] as $listName => $conf) {
 						if (t3lib_div::inList($conf, $className)) {
-							$JSClassesXORArray .= (($index)?',':'') . '"' . $className . '": /^(' . implode('|', t3lib_div::trimExplode(',', t3lib_div::rmFromList($className, $conf), 1)) . ')$/i' . $linebreak;
+							$JSClassesXORArray .= ($index?',':'') . '"' . $className . '": /^(' . implode('|', t3lib_div::trimExplode(',', t3lib_div::rmFromList($className, $conf), 1)) . ')$/i' . $linebreak;
 							break;
 						}
 					}
@@ -1086,12 +1037,84 @@
 		$JSClassesLabelsArray .= '};' . $linebreak;
 		$JSClassesValuesArray .= '};' . $linebreak;
 		$JSClassesNoShowArray .= '};' . $linebreak;
+		$JSClassesAlternatingArray .= '};' . $linebreak;
 		$JSClassesXORArray .= '};' . $linebreak;
 		
-		return $JSClassesLabelsArray . $JSClassesValuesArray . $JSClassesNoShowArray . $JSClassesXORArray;
+		return $JSClassesLabelsArray . $JSClassesValuesArray . $JSClassesNoShowArray . $JSClassesAlternatingArray . $JSClassesXORArray;
 	}
 	
 	/**
+	 * Translate Page TS Config array in JS nested array definition
+	 *
+	 * @param	array		$conf: Page TSConfig configuration array
+	 *
+	 * @return 	string		nested JS array definition
+	 */
+	function buildNestedJSArray($conf) {
+		$configureRTEInJavascriptString = '{';
+		$index = 0;
+		if (is_array($conf)) {
+			foreach ($conf as $propertyName => $conf1) {
+				$property = $propertyName;
+				if ($index) {
+					$configureRTEInJavascriptString .= ', ';
+				}
+				if (is_array($conf1)) {
+					$property = substr($property, 0, -1);
+					$indexProperty = 0;
+					$configureRTEInJavascriptString .= '"'.$property.'" : {';
+					foreach ($conf1 as $property1Name => $conf2) {
+						$property1 = $property1Name;
+						if ($indexProperty) {
+							$configureRTEInJavascriptString .= ', ';
+						}
+						if (is_array($conf2)) {
+							$property1 = substr($property1, 0, -1);
+							$indexProperty1 = 0;
+							$configureRTEInJavascriptString .= '"'.$property1.'" : {';
+							foreach ($conf2 as $property2Name => $conf3) {
+								$property2 = $property2Name;
+								if ($indexProperty1) {
+									$configureRTEInJavascriptString .= ', ';
+								}
+								if (is_array($conf3)) {
+									$property2 = substr($property2, 0, -1);
+									$indexProperty2 = 0;
+									$configureRTEInJavascriptString .= '"'.$property2.'" : {';
+									foreach($conf3 as $property3Name => $conf4) {
+										$property3 = $property3Name;
+										if ($indexProperty2) {
+											$configureRTEInJavascriptString .= ', ';
+										}
+										if (!is_array($conf4)) {
+											$configureRTEInJavascriptString .= '"'.$property3.'" : '.($conf4?'"'.$conf4.'"':'false');
+										}
+										$indexProperty2++;
+									}
+									$configureRTEInJavascriptString .= '}';
+								} else {
+									$configureRTEInJavascriptString .= '"'.$property2.'" : '.($conf3?'"'.$conf3.'"':'false');												
+								}
+								$indexProperty1++;
+							}
+							$configureRTEInJavascriptString .= '}';
+						} else {
+							$configureRTEInJavascriptString .= '"'.$property1.'" : '.($conf2?'"'.$conf2.'"':'false');
+						}
+						$indexProperty++;
+					}
+					$configureRTEInJavascriptString .= '}';
+				} else {
+					$configureRTEInJavascriptString .= '"'.$property.'" : '.($conf1?'"'.$conf1.'"':'false');
+				}
+				$index++;
+			}
+		}
+		$configureRTEInJavascriptString .= '}';
+		return $configureRTEInJavascriptString;
+	}
+	
+	/**
 	 * Return a Javascript localization array for htmlArea RTE
 	 *
 	 * @return	string		Javascript localization array
Index: typo3/sysext/rtehtmlarea/extensions/TableOperations/class.tx_rtehtmlarea_tableoperations.php
===================================================================
--- typo3/sysext/rtehtmlarea/extensions/TableOperations/class.tx_rtehtmlarea_tableoperations.php	(revision 3287)
+++ typo3/sysext/rtehtmlarea/extensions/TableOperations/class.tx_rtehtmlarea_tableoperations.php	(working copy)
@@ -42,19 +42,22 @@
 	protected $thisConfig;					// Reference to RTE PageTSConfig
 	protected $toolbar;					// Reference to RTE toolbar array
 	protected $LOCAL_LANG; 					// Frontend language array
+	protected $requiresClassesConfiguration = true;		// True if the registered plugin requires the PageTSConfig Classes configuration
 	
-	protected $pluginButtons = 'table, toggleborders, tableproperties, rowproperties, rowinsertabove, rowinsertunder, rowdelete, rowsplit,
-						columninsertbefore, columninsertafter, columndelete, columnsplit,
+	protected $pluginButtons = 'table, toggleborders, tableproperties, tablerestyle, rowproperties, rowinsertabove, rowinsertunder, rowdelete, rowsplit,
+						columnproperties, columninsertbefore, columninsertafter, columndelete, columnsplit,
 						cellproperties, cellinsertbefore, cellinsertafter, celldelete, cellsplit, cellmerge';
 	protected $convertToolbarForHtmlAreaArray = array (
 		'table'			=> 'InsertTable',
 		'toggleborders'		=> 'TO-toggle-borders',
 		'tableproperties'	=> 'TO-table-prop',
+		'tablerestyle'		=> 'TO-table-restyle',
 		'rowproperties'		=> 'TO-row-prop',
 		'rowinsertabove'	=> 'TO-row-insert-above',
 		'rowinsertunder'	=> 'TO-row-insert-under',
 		'rowdelete'		=> 'TO-row-delete',
 		'rowsplit'		=> 'TO-row-split',
+		'columnproperties'	=> 'TO-col-prop',
 		'columninsertbefore'	=> 'TO-col-insert-before',
 		'columninsertafter'	=> 'TO-col-insert-after',
 		'columndelete'		=> 'TO-col-delete',
@@ -96,13 +99,33 @@
 		$registerRTEinJavascriptString = '';
 		if (in_array('table', $this->toolbar)) {
 			
+				// Combining fieldset disablers as a list
+			$disabledFieldsets = array('Alignment', 'Borders', 'Color', 'Description', 'Layout', 'RowGroup', 'Spacing', 'Style');
+			foreach ($disabledFieldsets as $index => $fieldset) {
+				if (!trim($this->thisConfig['disable'.$fieldset.'FieldsetInTableOperations'])) {
+					unset($disabledFieldsets[$index]);
+				}
+			}
+			$disabledFieldsets = strtolower(implode(',', $disabledFieldsets));
+			
+				// Dialogue fieldsets removal configuration
+			$dialogues = array('table', 'tableproperties', 'rowproperties', 'columnproperties', 'cellproperties');
+			foreach ($dialogues as $dialogue) {
+				if (!is_array( $this->thisConfig['buttons.']) || !is_array( $this->thisConfig['buttons.'][$dialogue.'.'])) {
+					$registerRTEinJavascriptString .= '
+			RTEarea['.$RTEcounter.'].buttons.'.$dialogue.' = new Object();
+			RTEarea['.$RTEcounter.'].buttons.'.$dialogue.'.removeFieldsets = "' . $disabledFieldsets . '";';
+				} else if ($this->thisConfig['buttons.'][$dialogue.'.']['removeFieldsets']) {
+					$registerRTEinJavascriptString .= '
+			RTEarea['.$RTEcounter.'].buttons.'.$dialogue.'.removeFieldsets += ",' . $disabledFieldsets . '";';
+				} else {
+					$registerRTEinJavascriptString .= '
+			RTEarea['.$RTEcounter.'].buttons.'.$dialogue.'.removeFieldsets = ",' . $disabledFieldsets . '";';
+				}
+			}
+			
 			$registerRTEinJavascriptString .= '
-			RTEarea['.$RTEcounter.'].hideTableOperationsInToolbar = ' . (trim($this->thisConfig['hideTableOperationsInToolbar']) ? 'true' : 'false') . ';
-			RTEarea['.$RTEcounter.'].disableLayoutFieldsetInTableOperations = ' . (trim($this->thisConfig['disableLayoutFieldsetInTableOperations'])?'true':'false') . ';
-			RTEarea['.$RTEcounter.'].disableAlignmentFieldsetInTableOperations = ' . (trim($this->thisConfig['disableAlignmentFieldsetInTableOperations'])?'true':'false') . ';
-			RTEarea['.$RTEcounter.'].disableSpacingFieldsetInTableOperations = ' . (trim($this->thisConfig['disableSpacingFieldsetInTableOperations'])?'true':'false') . ';
-			RTEarea['.$RTEcounter.'].disableBordersFieldsetInTableOperations = ' . (trim($this->thisConfig['disableBordersFieldsetInTableOperations'])?'true':'false') . ';
-			RTEarea['.$RTEcounter.'].disableColorFieldsetInTableOperations = ' . (trim($this->thisConfig['disableColorFieldsetInTableOperations'])?'true':'false') . ';';
+			RTEarea['.$RTEcounter.'].hideTableOperationsInToolbar = ' . (trim($this->thisConfig['hideTableOperationsInToolbar']) ? 'true' : 'false') . ';';
 			
 				// Deprecated toggleborders button configuration
 			if (in_array('toggleborders',$this->toolbar) && $this->thisConfig['keepToggleBordersInToolbar']) {
Index: typo3/sysext/rtehtmlarea/extensions/TYPO3Color/class.tx_rtehtmlarea_typo3color.php
===================================================================
--- typo3/sysext/rtehtmlarea/extensions/TYPO3Color/class.tx_rtehtmlarea_typo3color.php	(revision 3287)
+++ typo3/sysext/rtehtmlarea/extensions/TYPO3Color/class.tx_rtehtmlarea_typo3color.php	(working copy)
@@ -50,7 +50,7 @@
 		);
 	
 	public function main($parentObject) {
-		return parent::main($parentObject) && !$this->thisConfig['disableSelectColor'];
+		return parent::main($parentObject) && (!$this->thisConfig['disableSelectColor'] || $this->htmlAreaRTE->client['BROWSER'] == 'gecko');
 	}
 	
 	/**
Index: typo3/sysext/rtehtmlarea/htmlarea/htmlarea-gecko.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/htmlarea-gecko.js	(revision 3287)
+++ typo3/sysext/rtehtmlarea/htmlarea/htmlarea-gecko.js	(working copy)
@@ -57,6 +57,7 @@
 		try {
 			this._doc.designMode = "on";
 			if (this._doc.queryCommandEnabled("insertbronreturn")) this._doc.execCommand("insertbronreturn", false, this.config.disableEnterParagraphs);
+			if (this._doc.queryCommandEnabled("enableObjectResizing")) this._doc.execCommand("enableObjectResizing", false, !this.config.disableObjectResizing);
 			if (this._doc.queryCommandEnabled("enableInlineTableEditing")) this._doc.execCommand("enableInlineTableEditing", false, (this.config.buttons.table && this.config.buttons.table.enableHandles) ? true : false);
 			if (this._doc.queryCommandEnabled("styleWithCSS")) this._doc.execCommand("styleWithCSS", false, this.config.useCSS);
 				else if (this._doc.queryCommandEnabled("useCSS")) this._doc.execCommand("useCSS", false, !this.config.useCSS);
@@ -464,6 +465,7 @@
 							editor.sizeIframe(-2);
 						}
 						if (editor._doc.queryCommandEnabled("insertbronreturn")) editor._doc.execCommand("insertbronreturn", false, editor.config.disableEnterParagraphs);
+						if (editor._doc.queryCommandEnabled("enableObjectResizing")) editor._doc.execCommand("enableObjectResizing", false, !editor.config.disableObjectResizing);
 						if (editor._doc.queryCommandEnabled("enableInlineTableEditing")) editor._doc.execCommand("enableInlineTableEditing", false, (editor.config.buttons.table && editor.config.buttons.table.enableHandles) ? true : false);
 						if (editor._doc.queryCommandEnabled("styleWithCSS")) editor._doc.execCommand("styleWithCSS", false, editor.config.useCSS);
 							else if (editor._doc.queryCommandEnabled("useCSS")) editor._doc.execCommand("useCSS", false, !editor.config.useCSS);
